commit c988768007b68ffec99b3138038cdde7e31c72a4
Author: Jingtao Chen <Jingtao.Chen@csr.com>
Date:   Wed Mar 9 11:06:44 2016 +0800

    Add Linux Foundation Copyright
    
    Change-Id: Id9870b3524cadbfe298add24608a5a750befc567
    Signed-off-by: Jingtao Chen <Jingtao.Chen@csr.com>

diff --git a/ext/wayland/gstwaylandsink.c b/ext/wayland/gstwaylandsink.c
index ec85e38..2b7476a 100644
--- a/ext/wayland/gstwaylandsink.c
+++ b/ext/wayland/gstwaylandsink.c
@@ -21,6 +21,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 /**
  * SECTION:element-waylandsink
  *
diff --git a/ext/wayland/gstwaylandsink.h b/ext/wayland/gstwaylandsink.h
index 350cc4a..1429914 100644
--- a/ext/wayland/gstwaylandsink.h
+++ b/ext/wayland/gstwaylandsink.h
@@ -19,6 +19,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifndef __GST_WAYLAND_VIDEO_SINK_H__
 #define __GST_WAYLAND_VIDEO_SINK_H__
 
diff --git a/ext/wayland/wlbuffer.c b/ext/wayland/wlbuffer.c
index 267079c..dbc0f0e 100644
--- a/ext/wayland/wlbuffer.c
+++ b/ext/wayland/wlbuffer.c
@@ -18,6 +18,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 /* GstWlBuffer wraps wl_buffer and provides a mechanism for preventing
  * buffers from being re-used while the compositor is using them. This
  * is achieved by adding a reference to the GstBuffer as soon as its
diff --git a/ext/wayland/wlbuffer.h b/ext/wayland/wlbuffer.h
index a13132f..206d0ae 100644
--- a/ext/wayland/wlbuffer.h
+++ b/ext/wayland/wlbuffer.h
@@ -18,6 +18,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifndef __GST_WL_BUFFER_H__
 #define __GST_WL_BUFFER_H__
 
diff --git a/ext/wayland/wldisplay.c b/ext/wayland/wldisplay.c
index 5c39912..93f0fab 100644
--- a/ext/wayland/wldisplay.c
+++ b/ext/wayland/wldisplay.c
@@ -18,6 +18,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifdef HAVE_CONFIG_H
 #include <config.h>
 #endif
diff --git a/ext/wayland/wldisplay.h b/ext/wayland/wldisplay.h
index f6ad3a5..de3e0e2 100644
--- a/ext/wayland/wldisplay.h
+++ b/ext/wayland/wldisplay.h
@@ -18,6 +18,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifndef __GST_WL_DISPLAY_H__
 #define __GST_WL_DISPLAY_H__
 
diff --git a/ext/wayland/wlshmallocator.c b/ext/wayland/wlshmallocator.c
index 4e0fdbc..a135239 100644
--- a/ext/wayland/wlshmallocator.c
+++ b/ext/wayland/wlshmallocator.c
@@ -20,6 +20,10 @@
  * Boston, MA 02110-1301, USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #include "wlshmallocator.h"
 #include "wlvideoformat.h"
 
diff --git a/ext/wayland/wlshmallocator.h b/ext/wayland/wlshmallocator.h
index e764946..e449f75 100644
--- a/ext/wayland/wlshmallocator.h
+++ b/ext/wayland/wlshmallocator.h
@@ -20,6 +20,10 @@
  * Boston, MA 02110-1301, USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifndef __GST_WL_SHM_ALLOCATOR_H__
 #define __GST_WL_SHM_ALLOCATOR_H__
 
diff --git a/ext/wayland/wlvideoformat.c b/ext/wayland/wlvideoformat.c
index d1e988a..a0e54b0 100644
--- a/ext/wayland/wlvideoformat.c
+++ b/ext/wayland/wlvideoformat.c
@@ -21,6 +21,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifdef HAVE_CONFIG_H
 #include <config.h>
 #endif
diff --git a/ext/wayland/wlvideoformat.h b/ext/wayland/wlvideoformat.h
index b5ec253..e1698e0 100644
--- a/ext/wayland/wlvideoformat.h
+++ b/ext/wayland/wlvideoformat.h
@@ -21,6 +21,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifndef __GST_WL_VIDEO_FORMAT_H__
 #define __GST_WL_VIDEO_FORMAT_H__
 
diff --git a/ext/wayland/wlwindow.c b/ext/wayland/wlwindow.c
index f934876..544e7c6 100644
--- a/ext/wayland/wlwindow.c
+++ b/ext/wayland/wlwindow.c
@@ -20,6 +20,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifdef HAVE_CONFIG_H
 #include <config.h>
 #endif
diff --git a/ext/wayland/wlwindow.h b/ext/wayland/wlwindow.h
index f6c8d78..b0a5b0d 100644
--- a/ext/wayland/wlwindow.h
+++ b/ext/wayland/wlwindow.h
@@ -18,6 +18,10 @@
  * Boston, MA 02110-1301 USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifndef __GST_WL_WINDOW_H__
 #define __GST_WL_WINDOW_H__
 
diff --git a/gst/mpegtsdemux/mpegtspacketizer.c b/gst/mpegtsdemux/mpegtspacketizer.c
index a1a16b2..ebadd63 100644
--- a/gst/mpegtsdemux/mpegtspacketizer.c
+++ b/gst/mpegtsdemux/mpegtspacketizer.c
@@ -22,6 +22,10 @@
  * Boston, MA 02110-1301, USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #include <string.h>
 #include <stdlib.h>
 
diff --git a/gst/mpegtsdemux/pesparse.c b/gst/mpegtsdemux/pesparse.c
index c2328c5..6e156dd 100644
--- a/gst/mpegtsdemux/pesparse.c
+++ b/gst/mpegtsdemux/pesparse.c
@@ -18,6 +18,10 @@
  * Boston, MA 02110-1301, USA.
  */
 
+/*
+ * Copyright (c) [2015-2016], The Linux Foundation. All rights reserved.
+ */
+
 #ifdef HAVE_CONFIG_H
 #include "config.h"
 #endif

commit 3aff0c58d79fade3caec90361be5c7554ec6c322
Author: Laisheng Hu <Laisheng.Hu@csr.com>
Date:   Tue Jan 26 17:24:28 2016 +0800

    support interlace mode video
    
    Change-Id: I45aeaff0ee00793920629ad13acc4345bda1a68a
    Signed-off-by: Laisheng Hu <Laisheng.Hu@csr.com>

diff --git a/ext/wayland/gstwaylandsink.c b/ext/wayland/gstwaylandsink.c
index c4e009d..ec85e38 100644
--- a/ext/wayland/gstwaylandsink.c
+++ b/ext/wayland/gstwaylandsink.c
@@ -461,7 +461,7 @@ gst_wayland_sink_set_caps (GstBaseSink * bsink, GstCaps * caps)
   if (!gst_video_info_from_caps (&info, caps))
     goto invalid_format;
 
-  format = gst_video_format_to_wl_shm_format (GST_VIDEO_INFO_FORMAT (&info));
+  format = gst_video_format_to_wl_shm_format (GST_VIDEO_INFO_FORMAT (&info),info.interlace_mode);
   if ((gint) format == -1)
     goto invalid_format;
 
diff --git a/ext/wayland/wlshmallocator.c b/ext/wayland/wlshmallocator.c
index 63aa2a8..4e0fdbc 100644
--- a/ext/wayland/wlshmallocator.c
+++ b/ext/wayland/wlshmallocator.c
@@ -59,7 +59,12 @@ gst_wl_shm_allocator_alloc (GstAllocator * allocator, gsize size,
   pFdData = g_slice_new0 (struct ion_fd_data);
   /* allocate ion buffer */
   if(size > PAGESIZE)
-    size = AL(info->width,64) * AL(info->height,16) * 3 / 2;
+  {
+    if(info->interlace_mode == GST_VIDEO_INTERLACE_MODE_PROGRESSIVE)
+       size = AL(info->width,64) * AL(info->height,32) * 3 / 2;
+    else
+       size = AL(info->width,64) * AL(info->height,32) * 3 / 2;
+  }
   size = AL(size,PAGESIZE);
 
   sAllocInfo.len          = size;
@@ -232,7 +237,7 @@ gst_wl_shm_memory_construct_wl_buffer (GstMemory * mem, GstWlDisplay * display,
   stride = AL(info->width,64); /* wl buffer stride should be aligned to 64 byte*/
 
   size = GST_VIDEO_INFO_SIZE (info);
-  format = gst_video_format_to_wl_shm_format (GST_VIDEO_INFO_FORMAT (info));
+  format = gst_video_format_to_wl_shm_format (GST_VIDEO_INFO_FORMAT (info),info->interlace_mode);
 
   g_return_val_if_fail (gst_is_wl_shm_memory (mem), NULL);
   g_return_val_if_fail (size <= mem->size, NULL);
diff --git a/ext/wayland/wlvideoformat.c b/ext/wayland/wlvideoformat.c
index ffb8de1..d1e988a 100644
--- a/ext/wayland/wlvideoformat.c
+++ b/ext/wayland/wlvideoformat.c
@@ -78,13 +78,20 @@ static const wl_VideoFormat formats[] = {
 };
 
 enum wl_shm_format
-gst_video_format_to_wl_shm_format (GstVideoFormat format)
+gst_video_format_to_wl_shm_format (GstVideoFormat format,GstVideoInterlaceMode interlace_mode)
 {
   guint i;
-
   for (i = 0; i < G_N_ELEMENTS (formats); i++)
     if (formats[i].gst_format == format)
-      return formats[i].wl_format;
+    {
+       if(format == GST_VIDEO_FORMAT_NV21)
+          return interlace_mode == GST_VIDEO_INTERLACE_MODE_PROGRESSIVE ?
+            WL_SHM_FORMAT_NV12_VXD:WL_SHM_FORMAT_NV12_VXD_INTERLACED;
+       else if(format == GST_VIDEO_FORMAT_YUY2)
+            GST_WARNING ("does wayland sink support this format?\n");
+       else
+         return formats[i].wl_format;
+    }
 
   GST_WARNING ("wayland shm video format not found");
   return -1;
diff --git a/ext/wayland/wlvideoformat.h b/ext/wayland/wlvideoformat.h
index e8ec7ae..b5ec253 100644
--- a/ext/wayland/wlvideoformat.h
+++ b/ext/wayland/wlvideoformat.h
@@ -29,7 +29,7 @@
 
 G_BEGIN_DECLS
 
-enum wl_shm_format gst_video_format_to_wl_shm_format (GstVideoFormat format);
+enum wl_shm_format gst_video_format_to_wl_shm_format (GstVideoFormat format,GstVideoInterlaceMode interlace_mode);
 GstVideoFormat gst_wl_shm_format_to_video_format (enum wl_shm_format wl_format);
 
 const gchar *gst_wl_shm_format_to_string (enum wl_shm_format wl_format);

commit 08a061c79d8452e9cc837d3c7db3cf4878bc7d06
Author: Laisheng Hu <Laisheng.Hu@csr.com>
Date:   Wed Jan 20 14:03:50 2016 +0800

    add wl_output_interface to get output panel format
    
    Change-Id: Ie4706844db9710724220f992918a930fe2c7ad68
    Signed-off-by: Laisheng Hu <Laisheng.Hu@csr.com>

diff --git a/ext/wayland/wldisplay.c b/ext/wayland/wldisplay.c
index 7d3420f..5c39912 100644
--- a/ext/wayland/wldisplay.c
+++ b/ext/wayland/wldisplay.c
@@ -154,6 +154,68 @@ shm_format (void *data, struct wl_shm *wl_shm, uint32_t format)
 static const struct wl_shm_listener shm_listener = {
   shm_format
 };
+ static void
+output_listener_geometry(void *data,
+                         struct wl_output *wl_output,
+                         int32_t x,
+                         int32_t y,
+                         int32_t physical_width,
+                         int32_t physical_height,
+                         int32_t subpixel,
+                         const char *make,
+                         const char *model,
+                         int32_t transform)
+{
+    (void)wl_output;
+    (void)x;
+    (void)y;
+    (void)subpixel;
+    (void)make;
+    (void)model;
+    (void)transform;
+}
+
+static void
+output_listener_mode(void *data,
+                     struct wl_output *wl_output,
+                     uint32_t flags,
+                     int32_t width,
+                     int32_t height,
+                     int32_t refresh)
+{
+    (void)data;
+    (void)wl_output;
+    (void)flags;
+    (void)width;
+    (void)height;
+    (void)refresh;
+	printf("%s : the mode in hardware units w %d h %d \r\n",__func__,width,height);
+}
+
+static void
+output_listener_done(void *data,
+                     struct wl_output *output)
+{
+    (void)data;
+    (void)output;
+}
+
+static void
+output_listener_scale(void *data,
+                      struct wl_output *output,
+                      int32_t factor)
+{
+    (void)data;
+    (void)output;
+    (void)factor;
+}
+
+static const struct wl_output_listener output_listener = {
+    output_listener_geometry,
+    output_listener_mode,
+    output_listener_done,
+    output_listener_scale
+};
 
 static void
 registry_handle_global (void *data, struct wl_registry *registry,
@@ -174,6 +236,10 @@ registry_handle_global (void *data, struct wl_registry *registry,
     wl_shm_add_listener (self->shm, &shm_listener, self);
   } else if (g_strcmp0 (interface, "wl_scaler") == 0) {
     self->scaler = wl_registry_bind (registry, id, &wl_scaler_interface, 2);
+  }else if(g_strcmp0 (interface, "wl_output") == 0) {
+     self->output = wl_registry_bind(registry, id, &wl_output_interface, 1);
+	 wl_output_add_listener(self->output, &output_listener, self);
+
   }
 }
 
diff --git a/ext/wayland/wldisplay.h b/ext/wayland/wldisplay.h
index f894d6b..f6ad3a5 100644
--- a/ext/wayland/wldisplay.h
+++ b/ext/wayland/wldisplay.h
@@ -52,6 +52,7 @@ struct _GstWlDisplay
   struct wl_shell *shell;
   struct wl_shm *shm;
   struct wl_scaler *scaler;
+  struct wl_output *output;
   GArray *formats;
 
   /* private */
diff --git a/ext/wayland/wlvideoformat.c b/ext/wayland/wlvideoformat.c
index efb915d..ffb8de1 100644
--- a/ext/wayland/wlvideoformat.c
+++ b/ext/wayland/wlvideoformat.c
@@ -95,6 +95,11 @@ gst_wl_shm_format_to_video_format (enum wl_shm_format wl_format)
 {
   guint i;
 
+  if (wl_format == WL_SHM_FORMAT_NV12_VXD_INTERLACED)
+    wl_format = WL_SHM_FORMAT_NV12_VXD;
+  if (wl_format == WL_SHM_FORMAT_YUYV_TWO_FIELDS)
+    wl_format = WL_SHM_FORMAT_YUYV;
+
   for (i = 0; i < G_N_ELEMENTS (formats); i++)
     if (formats[i].wl_format == wl_format)
       return formats[i].gst_format;

commit e22151c534c4be637cb62f8ec399ceb9a83a0b70
Author: Laisheng Hu <Laisheng.Hu@csr.com>
Date:   Tue Dec 22 10:06:33 2015 +0800

    enable overlay rendering
    
    Change-Id: I00273dfe0fcd5b6f993ebd6ee71a4f0f43fb2e3c
    Signed-off-by: Laisheng Hu <Laisheng.Hu@csr.com>

diff --git a/ext/wayland/wlwindow.c b/ext/wayland/wlwindow.c
index 985955f..f934876 100644
--- a/ext/wayland/wlwindow.c
+++ b/ext/wayland/wlwindow.c
@@ -289,6 +289,8 @@ void
 gst_wl_window_render (GstWlWindow * window, GstWlBuffer * buffer,
     const GstVideoInfo * info)
 {
+  struct wl_region *region;
+
   if (G_UNLIKELY (info)) {
     window->video_width =
         gst_util_uint64_scale_int_round (info->width, info->par_n, info->par_d);
@@ -305,6 +307,14 @@ gst_wl_window_render (GstWlWindow * window, GstWlBuffer * buffer,
 
   wl_surface_damage (window->video_surface, 0, 0, window->surface_width,
       window->surface_height);
+
+  /* support overlay rendering */
+  region = wl_compositor_create_region(window->display->compositor);
+  wl_region_add(region, 0, 0,
+    window->surface_width,window->surface_height);
+  wl_surface_set_opaque_region(window->video_surface, region);
+  wl_region_destroy(region);
+
   wl_surface_commit (window->video_surface);
 
   if (G_UNLIKELY (info)) {

commit cc4fb19d2aad6ea168a5d2076987d1e106533a96
Author: Laisheng Hu <Laisheng.Hu@csr.com>
Date:   Tue Dec 15 15:00:12 2015 +0800

    map the correct data for frame buffer
    
    Change-Id: I059b9a31b33f77ef789f0ed1cf70b81ed3520664
    Signed-off-by: Laisheng Hu <Laisheng.Hu@csr.com>

diff --git a/ext/wayland/wlshmallocator.c b/ext/wayland/wlshmallocator.c
index c118ec0..63aa2a8 100644
--- a/ext/wayland/wlshmallocator.c
+++ b/ext/wayland/wlshmallocator.c
@@ -149,7 +149,8 @@ gst_wl_shm_allocator_free (GstAllocator * allocator, GstMemory * memory)
 static gpointer
 gst_wl_shm_mem_map (GstMemory * mem, gsize maxsize, GstMapFlags flags)
 {
-  return ((GstWlShmMemory *) mem)->data;
+   struct ion_fd_data *pFdData  = ((GstWlShmMemory *) mem)->data;
+   return pFdData->handle;
 }
 
 static void

commit 1e4b41720ac587b65756a0f5c6caab9b41d99c43
Author: Laisheng Hu <Laisheng.Hu@csr.com>
Date:   Tue Dec 15 11:09:38 2015 +0800

    delay release gst_buffer
    
    Change-Id: I9ef8406fd9f693c5cf1460787ea2aec3a37cd722
    Signed-off-by: Laisheng Hu <Laisheng.Hu@csr.com>

diff --git a/ext/wayland/wlbuffer.c b/ext/wayland/wlbuffer.c
index 4ac99ef..267079c 100644
--- a/ext/wayland/wlbuffer.c
+++ b/ext/wayland/wlbuffer.c
@@ -135,11 +135,18 @@ buffer_release (void *data, struct wl_buffer *wl_buffer)
   GstWlBuffer *self = data;
 
   GST_LOG_OBJECT (self, "wl_buffer::release (GstBuffer: %p)", self->gstbuffer);
-
-  self->used_by_compositor = FALSE;
-
-  /* unref should be last, because it may end up destroying the GstWlBuffer */
-  gst_buffer_unref (self->gstbuffer);
+  /* add to the last */
+  wl_list_insert(self->display->defer_list.prev, &self->link);
+  if (wl_list_length(&self->display->defer_list) >= 2) {
+     struct wl_list *first = self->display->defer_list.next;
+     /* fetch the first defer free buffer and release it */
+     self = wl_container_of(first, self, link);
+     self->used_by_compositor = FALSE;
+     wl_list_remove(first);
+
+     /* unref should be last, because it may end up destroying the GstWlBuffer */
+     gst_buffer_unref (self->gstbuffer);
+  }
 }
 
 static const struct wl_buffer_listener buffer_listener = {
diff --git a/ext/wayland/wlbuffer.h b/ext/wayland/wlbuffer.h
index cbb50f7..a13132f 100644
--- a/ext/wayland/wlbuffer.h
+++ b/ext/wayland/wlbuffer.h
@@ -42,6 +42,9 @@ struct _GstWlBuffer
   struct wl_buffer * wlbuffer;
   GstBuffer *gstbuffer;
 
+  /* for defer free */
+  struct wl_list link;
+
   GstWlDisplay *display;
 
   gboolean used_by_compositor;
diff --git a/ext/wayland/wldisplay.c b/ext/wayland/wldisplay.c
index 8c5eeaf..7d3420f 100644
--- a/ext/wayland/wldisplay.c
+++ b/ext/wayland/wldisplay.c
@@ -58,6 +58,18 @@ gst_wl_display_finalize (GObject * gobject)
   gst_poll_set_flushing (self->wl_fd_poll, TRUE);
   g_thread_join (self->thread);
 
+   /* free all deferred release buffer */
+  if(!wl_list_empty(&self->defer_list))
+  {
+    GstWlBuffer *defer_buf, *tmp;
+    wl_list_for_each_safe(defer_buf, tmp, &self->defer_list, link)
+    {
+      defer_buf->used_by_compositor = FALSE;
+      wl_list_remove(&defer_buf->link);
+      /* unref should be last, because it may end up destroying the GstWlBuffer */
+      gst_buffer_unref (defer_buf->gstbuffer);
+    }
+  }
   /* to avoid buffers being unregistered from another thread
    * at the same time, take their ownership */
   g_mutex_lock (&self->buffers_mutex);
@@ -236,6 +248,8 @@ gst_wl_display_new_existing (struct wl_display * display,
   self->display = display;
   self->own_display = take_ownership;
 
+  wl_list_init(&self->defer_list);
+
   self->queue = wl_display_create_queue (self->display);
   self->registry = wl_display_get_registry (self->display);
   wl_proxy_set_queue ((struct wl_proxy *) self->registry, self->queue);
diff --git a/ext/wayland/wldisplay.h b/ext/wayland/wldisplay.h
index 5505d60..f894d6b 100644
--- a/ext/wayland/wldisplay.h
+++ b/ext/wayland/wldisplay.h
@@ -62,6 +62,9 @@ struct _GstWlDisplay
   GMutex buffers_mutex;
   GHashTable *buffers;
   gboolean shutting_down;
+
+  /* deferred free list for buffer release. */
+  struct wl_list defer_list;
 };
 
 struct _GstWlDisplayClass

commit 23d4b0c6190d42fc7540d9d664150873016c0b3f
Author: Laisheng Hu <Laisheng.Hu@csr.com>
Date:   Mon Nov 23 15:50:50 2015 +0800

    merge csr waylandsink patch in 1.6
    
    Change-Id: I40d7b01e15b8baacb976d2fc4b86ec14011cc927
    Signed-off-by: Laisheng Hu <Laisheng.Hu@csr.com>

diff --git a/configure.ac b/configure.ac
index d57c3e0..8847612 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1931,7 +1931,7 @@ AG_GST_CHECK_FEATURE(DIRECTFB, [directfb], dfbvideosink , [
 dnl **** Wayland ****
 translit(dnm, m, l) AM_CONDITIONAL(USE_WAYLAND, true)
 AG_GST_CHECK_FEATURE(WAYLAND, [wayland sink], wayland , [
-  PKG_CHECK_MODULES(WAYLAND, wayland-client >= 1.4.0 wayland-scanner, [
+  PKG_CHECK_MODULES(WAYLAND, wayland-client >= 1.4.0, [
     HAVE_WAYLAND="yes" ], [ HAVE_WAYLAND="no"
   ])
 ])
diff --git a/ext/wayland/Makefile.am b/ext/wayland/Makefile.am
index e12d99a..0e45fcc 100644
--- a/ext/wayland/Makefile.am
+++ b/ext/wayland/Makefile.am
@@ -1,5 +1,7 @@
 plugin_LTLIBRARIES = libgstwaylandsink.la
 
+I_DIR_ION=/usr/src/kernel/drivers/staging/android/uapi
+
 libgstwaylandsink_la_SOURCES =  \
 	gstwaylandsink.c \
 	wlshmallocator.c \
@@ -10,7 +12,7 @@ libgstwaylandsink_la_SOURCES =  \
 	scaler-protocol.c
 
 libgstwaylandsink_la_CFLAGS = $(GST_CFLAGS) $(GST_PLUGINS_BASE_CFLAGS) \
-                               $(WAYLAND_CFLAGS) $(GST_PLUGINS_BAD_CFLAGS)
+                               $(WAYLAND_CFLAGS) $(GST_PLUGINS_BAD_CFLAGS)  -I=$(I_DIR_ION)
 libgstwaylandsink_la_LIBADD = \
 	$(GST_PLUGINS_BASE_LIBS) \
 	-lgstvideo-$(GST_API_VERSION) \
diff --git a/ext/wayland/gstwaylandsink.c b/ext/wayland/gstwaylandsink.c
index 7cc4bba..c4e009d 100644
--- a/ext/wayland/gstwaylandsink.c
+++ b/ext/wayland/gstwaylandsink.c
@@ -60,7 +60,8 @@ enum
 enum
 {
   PROP_0,
-  PROP_DISPLAY
+  PROP_DISPLAY,
+  PROP_FULLSCREEN
 };
 
 GST_DEBUG_CATEGORY (gstwayland_debug);
@@ -158,6 +159,11 @@ gst_wayland_sink_class_init (GstWaylandSinkClass * klass)
       g_param_spec_string ("display", "Wayland Display name", "Wayland "
           "display name to connect to, if not supplied via the GstContext",
           NULL, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
+
+   g_object_class_install_property (gobject_class, PROP_FULLSCREEN,
+      g_param_spec_boolean ("fullscreen", "Fullscreen",
+          "Whether the surface should be made fullscreen", FALSE,
+          G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
 }
 
 static void
@@ -179,6 +185,11 @@ gst_wayland_sink_get_property (GObject * object,
       g_value_set_string (value, sink->display_name);
       GST_OBJECT_UNLOCK (sink);
       break;
+    case PROP_FULLSCREEN:
+      GST_OBJECT_LOCK (sink);
+      g_value_set_boolean (value, sink->fullscreen);
+      GST_OBJECT_UNLOCK (sink);
+      break;
     default:
       G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
       break;
@@ -197,6 +208,12 @@ gst_wayland_sink_set_property (GObject * object,
       sink->display_name = g_value_dup_string (value);
       GST_OBJECT_UNLOCK (sink);
       break;
+    case PROP_FULLSCREEN:
+      GST_OBJECT_LOCK (sink);
+      sink->fullscreen = g_value_get_boolean (value);
+      gst_wl_window_set_display(sink->window,&sink->video_info,sink->fullscreen);
+      GST_OBJECT_UNLOCK (sink);
+      break;
     default:
       G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
       break;
@@ -434,6 +451,7 @@ gst_wayland_sink_set_caps (GstBaseSink * bsink, GstCaps * caps)
   GArray *formats;
   gint i;
   GstStructure *structure;
+  GstWlShmAllocator *wl_allocator;
 
   sink = GST_WAYLAND_SINK (bsink);
 
@@ -464,7 +482,10 @@ gst_wayland_sink_set_caps (GstBaseSink * bsink, GstCaps * caps)
 
   structure = gst_buffer_pool_get_config (newpool);
   gst_buffer_pool_config_set_params (structure, caps, info.size, 2, 0);
-  gst_buffer_pool_config_set_allocator (structure, gst_wl_shm_allocator_get (),
+  wl_allocator = (GstWlShmAllocator *)gst_wl_shm_allocator_get ();
+  wl_allocator->info.width  = info.width;
+  wl_allocator->info.height  = info.height;
+  gst_buffer_pool_config_set_allocator (structure, wl_allocator,
       NULL);
   if (!gst_buffer_pool_set_config (newpool, structure))
     goto config_failed;
@@ -556,7 +577,6 @@ render_last_buffer (GstWaylandSink * sink)
 
   wlbuffer = gst_buffer_get_wl_buffer (sink->last_buffer);
   surface = gst_wl_window_get_wl_surface (sink->window);
-
   g_atomic_int_set (&sink->redraw_pending, TRUE);
   callback = wl_surface_frame (surface);
   wl_callback_add_listener (callback, &frame_callback_listener, sink);
@@ -590,13 +610,16 @@ gst_wayland_sink_render (GstBaseSink * bsink, GstBuffer * buffer)
     if (!sink->window) {
       /* if we were not provided a window, create one ourselves */
       sink->window =
-          gst_wl_window_new_toplevel (sink->display, &sink->video_info);
+          gst_wl_window_new_toplevel (sink->display, &sink->video_info,sink->fullscreen);
     }
   }
 
   /* drop buffers until we get a frame callback */
   if (g_atomic_int_get (&sink->redraw_pending) == TRUE)
-    goto done;
+  {
+	GST_WARNING_OBJECT (sink,"drop buffers until we get a frame callback");
+	 // goto done;
+  }
 
   /* make sure that the application has called set_render_rectangle() */
   if (G_UNLIKELY (sink->window->render_rectangle.w == 0))
@@ -665,7 +688,7 @@ gst_wayland_sink_render (GstBaseSink * bsink, GstBuffer * buffer)
 
   /* drop double rendering */
   if (G_UNLIKELY (to_render == sink->last_buffer)) {
-    GST_LOG_OBJECT (sink, "Buffer already being rendered");
+    GST_WARNING_OBJECT (sink,"Buffer already being rendered");
     goto done;
   }
 
@@ -673,7 +696,10 @@ gst_wayland_sink_render (GstBaseSink * bsink, GstBuffer * buffer)
   render_last_buffer (sink);
 
   if (buffer != to_render)
-    gst_buffer_unref (to_render);
+  {
+        GST_WARNING_OBJECT (sink,"buffer != to_render unref!");
+	gst_buffer_unref (to_render);
+  }
   goto done;
 
 no_window_size:
@@ -852,3 +878,4 @@ GST_PLUGIN_DEFINE (GST_VERSION_MAJOR,
     waylandsink,
     "Wayland Video Sink", plugin_init, VERSION, "LGPL", GST_PACKAGE_NAME,
     GST_PACKAGE_ORIGIN)
+
diff --git a/ext/wayland/gstwaylandsink.h b/ext/wayland/gstwaylandsink.h
index afbed40..350cc4a 100644
--- a/ext/wayland/gstwaylandsink.h
+++ b/ext/wayland/gstwaylandsink.h
@@ -65,6 +65,7 @@ struct _GstWaylandSink
   gboolean redraw_pending;
   GMutex render_lock;
   GstBuffer *last_buffer;
+  gboolean fullscreen;
 };
 
 struct _GstWaylandSinkClass
diff --git a/ext/wayland/wlshmallocator.c b/ext/wayland/wlshmallocator.c
index 6d82b23..c118ec0 100644
--- a/ext/wayland/wlshmallocator.c
+++ b/ext/wayland/wlshmallocator.c
@@ -30,54 +30,96 @@
 #include <unistd.h>
 #include <sys/mman.h>
 #include <sys/types.h>
+#include <ion.h>
+#include <fcntl.h>
 
 GST_DEBUG_CATEGORY_EXTERN (gstwayland_debug);
 #define GST_CAT_DEFAULT gstwayland_debug
 
+#define PAGESIZE 4096
+#define gst_wl_shm_allocator_parent_class parent_class
+
 G_DEFINE_TYPE (GstWlShmAllocator, gst_wl_shm_allocator, GST_TYPE_ALLOCATOR);
 
+#define AL(a,b) (((a)+(b)-1)&~((b)-1))
+
 static GstMemory *
 gst_wl_shm_allocator_alloc (GstAllocator * allocator, gsize size,
     GstAllocationParams * params)
 {
   GstWlShmAllocator *self = GST_WL_SHM_ALLOCATOR (allocator);
-  char filename[1024];
-  static int init = 0;
-  int fd;
   gpointer data;
   GstWlShmMemory *mem;
-
-  /* TODO: make use of the allocation params, if necessary */
-
-  /* allocate shm pool */
-  snprintf (filename, 1024, "%s/%s-%d-%s", g_get_user_runtime_dir (),
-      "wayland-shm", init++, "XXXXXX");
-
-  fd = g_mkstemp (filename);
-  if (fd < 0) {
-    GST_ERROR_OBJECT (self, "opening temp file %s failed: %s", filename,
-        strerror (errno));
+  GstVideoInfo *info = &(self->info);
+  struct ion_fd_data *pFdData ;
+  struct ion_handle_data sHandleData = {};
+  struct ion_allocation_data sAllocInfo;
+  gint fd,err;
+
+  pFdData = g_slice_new0 (struct ion_fd_data);
+  /* allocate ion buffer */
+  if(size > PAGESIZE)
+    size = AL(info->width,64) * AL(info->height,16) * 3 / 2;
+  size = AL(size,PAGESIZE);
+
+  sAllocInfo.len          = size;
+  sAllocInfo.align        = PAGESIZE;
+//	sAllocInfo.heap_id_mask = ION_HEAP_SYSTEM_MASK;
+  sAllocInfo.heap_id_mask  = ION_HEAP_TYPE_DMA_MASK;
+  sAllocInfo.flags = 0;
+
+  err = ioctl(self->ion_fd, ION_IOC_ALLOC, &sAllocInfo);
+  if(err)
+  {
+    GST_ERROR_OBJECT (self, "error ION_IOC_ALLOC");
     return NULL;
   }
-  if (ftruncate (fd, size) < 0) {
-    GST_ERROR_OBJECT (self, "ftruncate failed: %s", strerror (errno));
-    close (fd);
+  
+  pFdData->handle = sAllocInfo.handle;
+  sHandleData.handle = sAllocInfo.handle;
+  err = ioctl(self->ion_fd, ION_IOC_SHARE, pFdData);
+  if(err)
+  {
+    GST_ERROR_OBJECT (self, "error ION_IOC_SHARE");
+    ioctl(self->ion_fd, ION_IOC_FREE, &sHandleData);
     return NULL;
   }
 
-  data = mmap (NULL, size, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
-  if (data == MAP_FAILED) {
-    GST_ERROR_OBJECT (self, "mmap failed: %s", strerror (errno));
-    close (fd);
+  /* Now we have a share fd, we don't need the ion_handle in this
+   * process any more. Free it (which just drops the refcount).
+   */
+  err = ioctl(self->ion_fd, ION_IOC_FREE, &sHandleData);
+  if(err)
+  {
+    close(pFdData->fd);
+    return NULL;
+  }
+  fd = pFdData->fd;
+
+  data  = mmap(NULL, size, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
+  if ( data  == MAP_FAILED)
+  {
+    GST_ERROR_OBJECT (self, "mmap failed: for ION BUFFER");
+    ioctl(self->ion_fd, ION_IOC_FREE, &sHandleData);
+    close(fd);
     return NULL;
   }
 
-  unlink (filename);
+  if((data == NULL)||((guint32) (data) & 0xFFF))
+  {
+    GST_ERROR_OBJECT (self, " wayland ion buffer allocator failed!\n");
+    ioctl(self->ion_fd, ION_IOC_FREE, &sHandleData);
+    close(fd);
+    return NULL;
+  }
 
   mem = g_slice_new0 (GstWlShmMemory);
-  gst_memory_init ((GstMemory *) mem, GST_MEMORY_FLAG_NO_SHARE, allocator, NULL,
+  gst_memory_init ((GstMemory *) mem, 0, allocator, NULL,
       size, 0, 0, size);
-  mem->data = data;
+
+  pFdData->handle = data;
+  pFdData->fd = fd;
+  mem->data = pFdData;
   mem->fd = fd;
 
   return (GstMemory *) mem;
@@ -87,12 +129,21 @@ static void
 gst_wl_shm_allocator_free (GstAllocator * allocator, GstMemory * memory)
 {
   GstWlShmMemory *shm_mem = (GstWlShmMemory *) memory;
-
-  if (shm_mem->fd != -1)
-    close (shm_mem->fd);
-  munmap (shm_mem->data, memory->maxsize);
-
-  g_slice_free (GstWlShmMemory, shm_mem);
+  if(shm_mem != NULL)
+  {
+    struct ion_fd_data *ion_fd = shm_mem->data;
+
+    if(shm_mem->fd != -1)
+    {
+       ioctl(ion_fd, ION_IOC_IMPORT, ion_fd) ;
+       ioctl(ion_fd, ION_IOC_FREE, ion_fd);
+       if(ion_fd->handle != NULL)
+          munmap(ion_fd->handle, memory->size);
+       close (shm_mem->fd);
+       g_slice_free (struct ion_fd_data, ion_fd);
+    }
+    g_slice_free (GstWlShmMemory, shm_mem);
+  }
 }
 
 static gpointer
@@ -107,6 +158,19 @@ gst_wl_shm_mem_unmap (GstMemory * mem)
 }
 
 static void
+gst_wl_shm_allocator_finalize (GObject * obj)
+{
+  GstWlShmAllocator *allocator = (GstWlShmAllocator *) obj;
+
+  GST_LOG_OBJECT (obj, "called");
+
+  close (allocator->ion_fd);
+  allocator->ion_fd = -1;
+
+  G_OBJECT_CLASS (parent_class)->finalize (obj);
+}
+
+static void
 gst_wl_shm_allocator_class_init (GstWlShmAllocatorClass * klass)
 {
   GstAllocatorClass *alloc_class = (GstAllocatorClass *) klass;
@@ -123,6 +187,12 @@ gst_wl_shm_allocator_init (GstWlShmAllocator * self)
   self->parent_instance.mem_unmap = gst_wl_shm_mem_unmap;
 
   GST_OBJECT_FLAG_SET (self, GST_ALLOCATOR_FLAG_CUSTOM_ALLOC);
+  
+  self->ion_fd = open("/dev/ion", O_RDWR);
+  if (self->ion_fd < 0)
+  {
+    GST_ERROR_OBJECT (self,"error open dev/ion");
+  }
 }
 
 void
@@ -158,6 +228,8 @@ gst_wl_shm_memory_construct_wl_buffer (GstMemory * mem, GstWlDisplay * display,
   width = GST_VIDEO_INFO_WIDTH (info);
   height = GST_VIDEO_INFO_HEIGHT (info);
   stride = GST_VIDEO_INFO_PLANE_STRIDE (info, 0);
+  stride = AL(info->width,64); /* wl buffer stride should be aligned to 64 byte*/
+
   size = GST_VIDEO_INFO_SIZE (info);
   format = gst_video_format_to_wl_shm_format (GST_VIDEO_INFO_FORMAT (info));
 
@@ -173,8 +245,6 @@ gst_wl_shm_memory_construct_wl_buffer (GstMemory * mem, GstWlDisplay * display,
   wbuffer = wl_shm_pool_create_buffer (wl_pool, 0, width, height, stride,
       format);
 
-  close (shm_mem->fd);
-  shm_mem->fd = -1;
   wl_shm_pool_destroy (wl_pool);
 
   return wbuffer;
diff --git a/ext/wayland/wlshmallocator.h b/ext/wayland/wlshmallocator.h
index f12882c..e764946 100644
--- a/ext/wayland/wlshmallocator.h
+++ b/ext/wayland/wlshmallocator.h
@@ -53,6 +53,8 @@ struct _GstWlShmMemory
 struct _GstWlShmAllocator
 {
   GstAllocator parent_instance;
+  gint ion_fd;
+  GstVideoInfo info;
 };
 
 struct _GstWlShmAllocatorClass
diff --git a/ext/wayland/wlvideoformat.c b/ext/wayland/wlvideoformat.c
index 1302da6..efb915d 100644
--- a/ext/wayland/wlvideoformat.c
+++ b/ext/wayland/wlvideoformat.c
@@ -65,7 +65,7 @@ static const wl_VideoFormat formats[] = {
   {WL_SHM_FORMAT_YVYU, GST_VIDEO_FORMAT_YVYU},
   {WL_SHM_FORMAT_UYVY, GST_VIDEO_FORMAT_UYVY},
   {WL_SHM_FORMAT_AYUV, GST_VIDEO_FORMAT_AYUV},
-  {WL_SHM_FORMAT_NV12, GST_VIDEO_FORMAT_NV12},
+  {WL_SHM_FORMAT_NV12_VXD, GST_VIDEO_FORMAT_NV12},
   {WL_SHM_FORMAT_NV21, GST_VIDEO_FORMAT_NV21},
   {WL_SHM_FORMAT_NV16, GST_VIDEO_FORMAT_NV16},
   {WL_SHM_FORMAT_YUV410, GST_VIDEO_FORMAT_YUV9},
diff --git a/ext/wayland/wlwindow.c b/ext/wayland/wlwindow.c
index a964335..985955f 100644
--- a/ext/wayland/wlwindow.c
+++ b/ext/wayland/wlwindow.c
@@ -138,9 +138,11 @@ gst_wl_window_new_internal (GstWlDisplay * display)
       1, 1);
 
   buf = gst_buffer_new_allocate (gst_wl_shm_allocator_get (), info.size, NULL);
+#if 0 /* comment off  by lshu*/
   gst_buffer_map (buf, &mapinfo, GST_MAP_WRITE);
   *((guint32 *) mapinfo.data) = 0;      /* paint it black */
   gst_buffer_unmap (buf, &mapinfo);
+#endif
   wlbuf =
       gst_wl_shm_memory_construct_wl_buffer (gst_buffer_peek_memory (buf, 0),
       display, &info);
@@ -162,9 +164,28 @@ gst_wl_window_new_internal (GstWlDisplay * display)
 
   return window;
 }
+void *
+gst_wl_window_set_display (GstWlWindow *window, const GstVideoInfo * info,gboolean fullscreen)
+{
+  gint width;
+  if(window == NULL)
+    return;
+
+  if(fullscreen)
+    wl_shell_surface_set_fullscreen (window->shell_surface,
+      WL_SHELL_SURFACE_FULLSCREEN_METHOD_SCALE, 0, NULL);
+  else
+    wl_shell_surface_set_toplevel (window->shell_surface);
+
+  /* set the initial size to be the same as the reported video size */
+  width =
+      gst_util_uint64_scale_int_round (info->width, info->par_n, info->par_d);
+  gst_wl_window_set_render_rectangle (window, 0, 0, width, info->height);
+
+}
 
 GstWlWindow *
-gst_wl_window_new_toplevel (GstWlDisplay * display, const GstVideoInfo * info)
+gst_wl_window_new_toplevel (GstWlDisplay * display, const GstVideoInfo * info, gboolean fullscreen)
 {
   GstWlWindow *window;
   gint width;
@@ -178,7 +199,7 @@ gst_wl_window_new_toplevel (GstWlDisplay * display, const GstVideoInfo * info)
   if (window->shell_surface) {
     wl_shell_surface_add_listener (window->shell_surface,
         &shell_surface_listener, window);
-    wl_shell_surface_set_toplevel (window->shell_surface);
+    gst_wl_window_set_display(window,info,fullscreen);
   } else {
     GST_ERROR ("Unable to get wl_shell_surface");
 
@@ -186,10 +207,6 @@ gst_wl_window_new_toplevel (GstWlDisplay * display, const GstVideoInfo * info)
     return NULL;
   }
 
-  /* set the initial size to be the same as the reported video size */
-  width =
-      gst_util_uint64_scale_int_round (info->width, info->par_n, info->par_d);
-  gst_wl_window_set_render_rectangle (window, 0, 0, width, info->height);
 
   return window;
 }
@@ -312,6 +329,9 @@ gst_wl_window_set_render_rectangle (GstWlWindow * window, gint x, gint y,
   window->render_rectangle.y = y;
   window->render_rectangle.w = w;
   window->render_rectangle.h = h;
+   /* video resolution is also changed*/
+  window->video_width = w;
+  window->video_height = h;
 
   /* position the area inside the parent - needs a parent commit to apply */
   if (window->area_subsurface)
diff --git a/ext/wayland/wlwindow.h b/ext/wayland/wlwindow.h
index e22cb26..f6c8d78 100644
--- a/ext/wayland/wlwindow.h
+++ b/ext/wayland/wlwindow.h
@@ -65,8 +65,11 @@ struct _GstWlWindowClass
 
 GType gst_wl_window_get_type (void);
 
+void * gst_wl_window_set_display (GstWlWindow *window,
+        const GstVideoInfo * info,gboolean fullscreen);
+
 GstWlWindow *gst_wl_window_new_toplevel (GstWlDisplay * display,
-        const GstVideoInfo * info);
+        const GstVideoInfo * info, gboolean fullscreen);
 GstWlWindow *gst_wl_window_new_in_surface (GstWlDisplay * display,
         struct wl_surface * parent);
 

commit 0923bc9f412baa94cb8e2178ce2ef24fc5c3c286
Author: Jingtao Chen <Jingtao.Chen@csr.com>
Date:   Wed Jun 17 16:25:25 2015 +0800

    Bugfix for APBU-10500
    
    Sometimes when pts < first pcr, tsdemux will return incorrect timestamp.
    This patch handle such issue.
    
    This issue could also be reproduced with A7 kitkat. With this patch,
    we can play these ts streams both on A7 Linux and A7 kitkat.
    
    KNOWN ISSUE:
    For 封装TS-后窗惊魂试机片段.ts
    1. When doing accurate seek to some specific time, gstreamer might hang
    2. A7 kitkat use accurate seek but A7 Linux not.
    3. We can quit and play other streams on A7 kitkat after such hang.
    4. Such hang can be reproduced on PC.
    5. GStreamer 1.4.4 or 1.4.5 + this patch might result in such hang but
       not for 1.5.1. We need recheck this problem after next upgrade.
    
    Conflicts:
        gst/mpegtsdemux/tsdemux.c
    
    Change-Id: Ib02adcde06e8af963cd5898b2e49ebf13b4b84c5
    Signed-off-by: Jingtao Chen <Jingtao.Chen@csr.com>

diff --git a/gst/mpegtsdemux/mpegtspacketizer.c b/gst/mpegtsdemux/mpegtspacketizer.c
index 1cdb9e9..a1a16b2 100644
--- a/gst/mpegtsdemux/mpegtspacketizer.c
+++ b/gst/mpegtsdemux/mpegtspacketizer.c
@@ -2240,13 +2240,6 @@ mpegts_packetizer_pts_to_ts (MpegTSPacketizer2 * packetizer,
       refpcr = group->first_pcr;
       refpcroffset = group->pcr_offset;
       if (pts < PCRTIME_TO_GSTTIME (refpcr)) {
-        /* Only apply wrapover if we're certain it is, and avoid
-         * returning bogus values if it's a PTS/DTS which is *just*
-         * before the start of the current group
-         */
-        if (PCRTIME_TO_GSTTIME (refpcr) - pts > GST_SECOND) {
-          pts += PCR_GST_MAX_VALUE;
-        } else
           refpcr = G_MAXINT64;
       }
     } else {
@@ -2285,8 +2278,13 @@ mpegts_packetizer_pts_to_ts (MpegTSPacketizer2 * packetizer,
         GST_DEBUG ("Using group !");
         refpcr = group->first_pcr;
         refpcroffset = group->pcr_offset;
-        if (pts < refpcr)
-          refpcr -= PCR_MAX_VALUE;
+        if (pts < PCRTIME_TO_GSTTIME(refpcr))
+		{
+			if (refpcr > PCR_MAX_VALUE)
+			    refpcr -= PCR_MAX_VALUE;
+			else
+			    refpcr = G_MAXINT64;
+		}
       }
     }
     if (refpcr != G_MAXINT64)

commit c3573582d635f8dd01f33d851bfa447ade4bb54d
Author: Jingtao Chen <Jingtao.Chen@csr.com>
Date:   Thu May 28 15:27:32 2015 +0800

    Bugfix for APBU-10448
    
    For some specific mpegts file, first several DTS in pes header is
    larger than PTS. Set DTS equals to PTS.
    
    APBU-7629 is the same.
    
    Change-Id: Icb3f970b45f62ef5c7fee20acecfc8cc4b408574
    Signed-off-by: Jingtao Chen <Jingtao.Chen@csr.com>

diff --git a/gst/mpegtsdemux/pesparse.c b/gst/mpegtsdemux/pesparse.c
index 1d7a3b6..c2328c5 100644
--- a/gst/mpegtsdemux/pesparse.c
+++ b/gst/mpegtsdemux/pesparse.c
@@ -166,6 +166,10 @@ mpegts_parse_pes_header (const guint8 * data, gsize length, PESHeader * res)
     READ_TS (data, res->DTS, bad_DTS_value);
     length -= 5;
 
+    /* Jingtao: pts should not be less than dts */
+    if (res->DTS > res->PTS)
+        res->DTS = res->PTS;
+
     GST_LOG ("DTS %" G_GUINT64_FORMAT " %" GST_TIME_FORMAT,
         res->DTS, GST_TIME_ARGS (MPEGTIME_TO_GSTTIME (res->DTS)));
   }
